searchData={"content_type":"text/markdown","items":[{"doc":"Module that contains the functions to use the Binary search.","ref":"Bsearch.html","title":"Bsearch","type":"module"},{"doc":"Returns the index of the position of a value inside the tuple, if the value is not present, it will return\nan tuple with error status.","ref":"Bsearch.html#find_index/2","title":"Bsearch.find_index/2","type":"function"},{"doc":"iex> Bsearch.find_index({1, 2, 3}, 1)\n    {:ok, 0}\n\n    iex> Bsearch.find_index({1, 2, 3}, 2)\n    {:ok, 1}\n\n    iex> Bsearch.find_index({1, 2, 3}, 3)\n    {:ok, 2}\n\n    iex> Bsearch.find_index({1, 2, 3}, 0)\n    {:error, :not_found}\n\n    iex> Bsearch.find_index({1, 2, 3}, 4)\n    {:error, :not_found}","ref":"Bsearch.html#find_index/2-examples","title":"Examples - Bsearch.find_index/2","type":"function"},{"doc":"Returns true of false of whether a tuple contains a certain value.","ref":"Bsearch.html#member?/2","title":"Bsearch.member?/2","type":"function"},{"doc":"iex> Bsearch.member?({1, 2, 3}, 1)\n    true\n\n    iex> Bsearch.member?({1, 2, 3}, 2)\n    true\n\n    iex> Bsearch.member?({1, 2, 3}, 3)\n    true\n\n    iex> Bsearch.member?({1, 2, 3}, 0)\n    false\n\n    iex> Bsearch.member?({1, 2, 3}, 4)\n    false","ref":"Bsearch.html#member?/2-examples","title":"Examples - Bsearch.member?/2","type":"function"},{"doc":"Binary search only works on ordered tuples, so this function normalizes a tuple or a list","ref":"Bsearch.html#normalize/1","title":"Bsearch.normalize/1","type":"function"},{"doc":"iex> Bsearch.normalize([3, 2, 1])\n    {1, 2, 3}\n\n    iex> Bsearch.normalize([2, 3, 2])\n    {2, 3}\n\n    iex> Bsearch.normalize({3, 2, 1})\n    {1, 2, 3}\n\n    iex> Bsearch.normalize({3, 3, 1})\n    {1, 3}","ref":"Bsearch.html#normalize/1-examples","title":"Examples - Bsearch.normalize/1","type":"function"},{"doc":"# Bsearch\n\nImplementation of a binary search using tuples.","ref":"readme.html","title":"Bsearch","type":"extras"},{"doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `bsearch` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:bsearch, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - Bsearch","type":"extras"},{"doc":"- member?/find_index\n  - use module.compare to compare certain data types\n  - find by function - like use a function to enter a map or something\n- valid? - check if the tuple is valid to be used by the binary search","ref":"readme.html#todo","title":"TODO - Bsearch","type":"extras"},{"doc":"MIT License\n\nCopyright (c) 2023 Gabriel Oliveira\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]}